/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PropRole
 *  fire.pb.battle.ai.BattleAIAgent
 *  fire.pb.buff.BuffAgent
 *  fire.pb.buff.BuffConstant
 *  fire.pb.buff.BuffMonsterImpl
 *  fire.pb.buff.BuffPetImpl
 *  fire.pb.buff.BuffRoleImpl
 *  fire.pb.buff.Module
 *  fire.pb.buff.continual.ConstantlyBuffConfig
 *  fire.pb.buff.continual.DecisionBuff
 *  fire.pb.effect.Module
 *  fire.pb.effect.Role
 *  fire.pb.main.ConfigManager
 *  fire.pb.skill.Result
 *  fire.pb.skill.SNuqiget
 *  fire.pb.skill.SkillAgent
 *  fire.pb.skill.SkillMonster
 *  fire.pb.skill.SkillPet
 *  fire.pb.skill.SkillRole
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.BattleInfo
 *  xbean.Buff
 *  xbean.Fighter
 *  xbean.Monster
 *  xbean.PetInfo
 *  xbean.Pets
 *  xtable.Pet
 */
package fire.pb.battle;

import fire.pb.PropRole;
import fire.pb.battle.ActionChangedAttrs;
import fire.pb.battle.BattleField;
import fire.pb.battle.SSendAlreadyUseItem;
import fire.pb.battle.ai.BattleAIAgent;
import fire.pb.buff.BuffAgent;
import fire.pb.buff.BuffConstant;
import fire.pb.buff.BuffMonsterImpl;
import fire.pb.buff.BuffPetImpl;
import fire.pb.buff.BuffRoleImpl;
import fire.pb.buff.continual.ConstantlyBuffConfig;
import fire.pb.buff.continual.DecisionBuff;
import fire.pb.effect.Module;
import fire.pb.effect.Role;
import fire.pb.main.ConfigManager;
import fire.pb.skill.Result;
import fire.pb.skill.SNuqiget;
import fire.pb.skill.SkillAgent;
import fire.pb.skill.SkillMonster;
import fire.pb.skill.SkillPet;
import fire.pb.skill.SkillRole;
import java.util.Iterator;
import java.util.Map;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.BattleInfo;
import xbean.Buff;
import xbean.Monster;
import xbean.PetInfo;
import xbean.Pets;
import xtable.Pet;

public class Fighter {
    protected BattleInfo battle;
    protected int fighterId;
    protected xbean.Fighter fighterbean;
    protected BuffAgent buffagent;
    protected SkillAgent skillagent;
    protected Role erole;
    protected BattleAIAgent aiagent;
    protected int saveRoleNum;
    private Result roundBuffResult = new Result(true);
    int tempSpeed = 0;
    int nFighterStar = 0;
    protected int nOwnerindx = 0;
    protected int bounusnum = 0;
    private boolean doubleSkill = false;

    public int getFightertype() {
        return this.fighterbean.getFightertype();
    }

    public boolean isRole() {
        return this.getFightertype() == 1;
    }

    public boolean isPet() {
        return this.getFightertype() == 2;
    }

    public void setOwner(int nindex) {
        this.nOwnerindx = nindex;
    }

    public int getOwner() {
        return this.nOwnerindx;
    }

    public boolean isPartner() {
        return this.getFightertype() == 3 || this.getFightertype() == 6;
    }

    public Fighter(BattleInfo battle, int fighterId) {
        if (battle == null) {
            throw new IllegalArgumentException("xbean.BattleInfo is null");
        }
        this.battle = battle;
        xbean.Fighter fighterbean = (xbean.Fighter)battle.getFighters().get(fighterId);
        if (fighterbean == null) {
            throw new IllegalArgumentException("Fighter does not exist. Id = " + fighterId);
        }
        this.fighterId = fighterId;
        this.fighterbean = fighterbean;
        int type = fighterbean.getFightertype();
        switch (type) {
            case 1: {
                long roleId = fighterbean.getUniqueid();
                this.buffagent = new BuffRoleImpl(roleId);
                this.skillagent = new SkillRole(roleId);
                this.aiagent = new BattleAIAgent(this, battle);
                break;
            }
            case 2: {
                long masterId = ((xbean.Fighter)battle.getFighters().get(fighterId - 5)).getUniqueid();
                PropRole prole = new PropRole(masterId, true);
                int petkey = prole.getFightpetkey();
                if (petkey < 0) {
                    throw new IllegalArgumentException("No fight pet. roleId = " + masterId);
                }
                this.buffagent = new BuffPetImpl(masterId, petkey);
                Pets petsBean = Pet.get((Long)masterId);
                this.skillagent = new SkillPet((PetInfo)petsBean.getPetmap().get(petkey), masterId);
                this.aiagent = null;
                break;
            }
            case 3: 
            case 4: 
            case 5: 
            case 6: {
                Monster monsterbean = (Monster)battle.getMonsters().get(fighterId);
                this.buffagent = new BuffMonsterImpl(monsterbean);
                long leaderid = 0L;
                if (fighterbean.getFightertype() == 3) {
                    leaderid = battle.getBattletype() == 11 ? (fighterId > 14 ? ((xbean.Fighter)battle.getFighters().get(15)).getUniqueid() : ((xbean.Fighter)battle.getFighters().get(1)).getUniqueid()) : ((xbean.Fighter)battle.getFighters().get(1)).getUniqueid();
                }
                this.skillagent = new SkillMonster(monsterbean, leaderid);
                this.aiagent = new BattleAIAgent(this, battle);
                break;
            }
            default: {
                throw new IllegalArgumentException("Fighter Type is wrong");
            }
        }
        this.erole = this.buffagent.getERole();
    }

    protected Fighter() {
    }

    public BattleInfo getBattle() {
        return this.battle;
    }

    public int getFighterId() {
        return this.fighterId;
    }

    public xbean.Fighter getFighterBean() {
        return this.fighterbean;
    }

    public int getSeqSpeed() {
        return this.erole.getSpeed() + this.tempSpeed;
    }

    public BuffAgent getBuffAgent() {
        return this.buffagent;
    }

    public Role getEffectRole() {
        return this.erole;
    }

    public SkillAgent getSkillAgent() {
        return this.skillagent;
    }

    public int healHp(int v) {
        return this.erole.addHp(v);
    }

    public int attachHpChange(int v) {
        int hpchange = this.erole.addHp(v);
        int addsp = this.getAddSpFromHpChange(hpchange);
        if (addsp <= 0) {
            return v;
        }
        if (this.getSkillAgent().hasEffectSkill(430026)) {
            addsp = (int)((double)addsp * 1.2);
        }
        this.erole.addSp(addsp, 0);
        this.getRoundBuffResult().getChangedAttrs().put(120, Float.valueOf(this.erole.getSp()));
        return v;
    }

    protected int getAddSpFromHpChange(int hpchange) {
        if (this.fighterbean.getFightertype() != 1) {
            return 0;
        }
        if (hpchange >= 0) {
            return 0;
        }
        if (this.erole.getMaxHp() <= 0) {
            return 0;
        }
        hpchange = -hpchange;
        int ratio = hpchange * 100 / this.erole.getMaxHp();
        float angryExtra = 1.0f;
        for (SNuqiget get : ConfigManager.getInstance().getConf(SNuqiget.class).values()) {
            if (ratio < get.hurtmin || ratio >= get.hurtmax) continue;
            return (int)((float)get.nuqiget * angryExtra);
        }
        return 0;
    }

    public int attachMpChange(int v) {
        return this.erole.addMp(v);
    }

    public Result getRoundBuffResult() {
        return this.roundBuffResult;
    }

    public Result updateRoundBuffResult(Result newbuffResult) {
        this.roundBuffResult.updateResult(newbuffResult);
        return this.roundBuffResult;
    }

    public void storeActionAttrsChange(int actcount) {
        if (this.roundBuffResult.getChangedAttrs().size() == 0) {
            return;
        }
        if (this.fighterbean.getFightertype() != 1 && this.fighterbean.getFightertype() != 2) {
            return;
        }
        ActionChangedAttrs actionAttrs = (ActionChangedAttrs)this.battle.getFighterchangedattrs().get(this.fighterId);
        if (actionAttrs == null) {
            actionAttrs = new ActionChangedAttrs();
            this.battle.getFighterchangedattrs().put(this.fighterId, actionAttrs);
        }
        actionAttrs.getChangedAttrs().put(actcount, Module.getClientAttrs((Map)this.roundBuffResult.getChangedAttrs()));
        this.roundBuffResult.getChangedAttrs().clear();
    }

    public boolean canAction(int operationType, int operationId) {
        if (!this.validLimitOperationBuffs(operationType)) {
            return false;
        }
        switch (operationType) {
            case 1: {
                if (this.buffagent.existBuff(505005)) {
                    return false;
                }
                if (this.buffagent.existBuff(504011) || this.buffagent.existBuff(509131)) {
                    return false;
                }
                if (this.buffagent.existBuff(509131)) {
                    return false;
                }
                if (this.buffagent.existBuff(500033)) {
                    return false;
                }
                if (this.buffagent.existBuff(509084)) {
                    return false;
                }
                if (this.buffagent.existBuff(502004) || this.buffagent.existBuff(502009)) {
                    return false;
                }
                if (this.buffagent.existBuff(502003)) {
                    return false;
                }
            }
            case 2: {
                if (this.buffagent.existBuff(505005)) {
                    return false;
                }
                if (this.buffagent.existBuff(504011) || this.buffagent.existBuff(509131)) {
                    return false;
                }
                if (this.buffagent.existBuff(502002) && (operationId != 100004 || operationId != 100003)) {
                    return false;
                }
                if (this.buffagent.existBuff(502003)) {
                    return false;
                }
                if (this.buffagent.existBuff(509131)) {
                    return false;
                }
                if (this.buffagent.existBuff(500033)) {
                    return false;
                }
                if (this.buffagent.existBuff(509084)) {
                    return false;
                }
                if ((this.buffagent.existBuff(502004) || this.buffagent.existBuff(502009)) && operationId != 100004) {
                    return false;
                }
            }
            case 19: {
                if (this.buffagent.existBuff(500033)) {
                    return false;
                }
                if (this.buffagent.existBuff(509084)) {
                    return false;
                }
                if (this.buffagent.existBuff(502004)) {
                    return false;
                }
            }
            case 11: {
                if (this.buffagent.existBuff(505005)) {
                    return false;
                }
                if (this.buffagent.existBuff(504011) || this.buffagent.existBuff(509131)) {
                    return false;
                }
                if (this.buffagent.existBuff(509131)) {
                    return false;
                }
                if (this.buffagent.existBuff(500033)) {
                    return false;
                }
                if (this.buffagent.existBuff(509084)) {
                    return false;
                }
                if (this.buffagent.existBuff(502004)) {
                    return false;
                }
            }
            case 3: {
                if (this.buffagent.existBuff(505005)) {
                    return false;
                }
                if (this.buffagent.existBuff(504011) || this.buffagent.existBuff(509131)) {
                    return false;
                }
                if (this.buffagent.existBuff(509131)) {
                    return false;
                }
                if (this.buffagent.existBuff(500033)) {
                    return false;
                }
                if (this.buffagent.existBuff(509084)) {
                    return false;
                }
                if (this.buffagent.existBuff(502004) || this.buffagent.existBuff(502009)) {
                    return false;
                }
            }
            case 5: {
                if (this.buffagent.existBuff(505005)) {
                    return false;
                }
                if (this.buffagent.existBuff(504011) || this.buffagent.existBuff(509131)) {
                    return false;
                }
                if (this.buffagent.existBuff(502003)) {
                    return false;
                }
                if (this.buffagent.existBuff(509131)) {
                    return false;
                }
                if (this.buffagent.existBuff(500033)) {
                    return false;
                }
                if (this.buffagent.existBuff(509084)) {
                    return false;
                }
                if (this.buffagent.existBuff(502004) || this.buffagent.existBuff(502009)) {
                    return false;
                }
            }
            case 6: {
                if (this.buffagent.existBuff(505005)) {
                    return false;
                }
                if (this.buffagent.existBuff(504011) || this.buffagent.existBuff(509131)) {
                    return false;
                }
                if (this.buffagent.existBuff(500033)) {
                    return false;
                }
                if (this.buffagent.existBuff(509084)) {
                    return false;
                }
            }
            case 12: {
                return true;
            }
            case 4: {
                if (this.buffagent.existBuff(509131)) {
                    return false;
                }
                if (this.buffagent.existBuff(502004) || this.buffagent.existBuff(502009)) {
                    return false;
                }
            }
            case 13: {
                return true;
            }
            case 9: {
                if (this.buffagent.existBuff(500033)) {
                    return false;
                }
                if (this.buffagent.existBuff(509084)) {
                    return false;
                }
            }
            case 8: {
                if (this.battle.getBattletype() != 40 || this.getBounusNum() > 0) break;
                return false;
            }
            default: {
                if (this.buffagent.existBuff(505005)) {
                    return false;
                }
                if (this.buffagent.existBuff(504011) || this.buffagent.existBuff(509131)) {
                    return false;
                }
                if (this.buffagent.existBuff(509131)) {
                    return false;
                }
                if (this.buffagent.existBuff(500033)) {
                    return false;
                }
                if (!this.buffagent.existBuff(509084)) break;
                return false;
            }
        }
        return true;
    }

    private boolean validLimitOperationBuffs(int operationType) {
        Iterator iterator = fire.pb.buff.Module.getInstance().getLimitBuffIdsByOperType(operationType).iterator();
        while (iterator.hasNext()) {
            int buffId = (Integer)iterator.next();
            if (!this.buffagent.existBuff(buffId)) continue;
            return false;
        }
        return true;
    }

    public boolean canBeAction(int operationType) {
        switch (operationType) {
            case 1: 
            case 5: {
                if (this.buffagent.existBuff(500033)) {
                    return false;
                }
                if (!this.buffagent.existBuff(509084)) break;
                return false;
            }
            case 8: {
                if (this.buffagent.existBuff(500033)) {
                    return false;
                }
                if (!this.buffagent.existBuff(509084)) break;
                return false;
            }
        }
        return true;
    }

    public int getTempSpeed() {
        return this.tempSpeed;
    }

    public void setTempSpeed(int tempSpeed) {
        this.tempSpeed = tempSpeed;
    }

    public BattleAIAgent getAiagent() {
        return this.aiagent;
    }

    public void setDoubleSkill(boolean doubleSkill) {
        this.doubleSkill = doubleSkill;
    }

    public boolean isDoubleSkill() {
        return this.doubleSkill;
    }

    public DecisionBuff getDecisonBuff() {
        for (Map.Entry entry : this.getBuffAgent().getAgent().getBuffs().entrySet()) {
            int buffId = (Integer)entry.getKey();
            ConstantlyBuffConfig cfg = fire.pb.buff.Module.getInstance().getDefaultCBuffConfig(buffId);
            if (!cfg.getClassName().equals(BuffConstant.DECISON_BUFF_CLASS_NAME)) continue;
            return (DecisionBuff)fire.pb.buff.Module.getInstance().createConstantlyBuff((Buff)entry.getValue());
        }
        return this.getHateDecisonBuff();
    }

    public DecisionBuff getHateDecisonBuff() {
        for (Map.Entry entry : this.getBuffAgent().getAgent().getBuffs().entrySet()) {
            int buffId = (Integer)entry.getKey();
            ConstantlyBuffConfig cfg = fire.pb.buff.Module.getInstance().getDefaultCBuffConfig(buffId);
            if (!cfg.getClassName().equals(BuffConstant.HATEDECISON_BUFF_CLASS_NAME)) continue;
            if (BattleField.checkOutBattle(this.battle, ((Float)((Buff)entry.getValue()).getEffects().get(1591)).intValue()) || !((Fighter)this.battle.getFighterobjects().get(((Float)((Buff)entry.getValue()).getEffects().get(1591)).intValue())).canBeAction(1)) {
                return null;
            }
            return (DecisionBuff)fire.pb.buff.Module.getInstance().createConstantlyBuff((Buff)entry.getValue());
        }
        return null;
    }

    public int getSaveRoleNum() {
        return this.saveRoleNum;
    }

    public void setSaveRoleNum(int saveRoleNum) {
        this.saveRoleNum = saveRoleNum;
    }

    public int getBounusNum() {
        return this.bounusnum;
    }

    public void setBounusNum(int bounusnum) {
        this.bounusnum = bounusnum;
    }

    public void sendAlreadyUsedItems() {
        if (this.getFightertype() != 1) {
            return;
        }
        if (this.getFighterBean().getUseditems().isEmpty()) {
            return;
        }
        SSendAlreadyUseItem sSendAlreadyUseItem = new SSendAlreadyUseItem();
        sSendAlreadyUseItem.itemlist.putAll(this.getFighterBean().getUseditems());
        Procedure.psendWhileCommit((long)this.getFighterBean().getUniqueid(), (Protocol)sSendAlreadyUseItem);
    }

    public boolean cankickout(Fighter killer) {
        if (this.getFightertype() > 1) {
            if (this.getBuffAgent().existBuff(509029) || this.getBuffAgent().existBuff(509066)) {
                if (killer != null && (killer.getBuffAgent().existBuff(508140) || killer.getBuffAgent().existBuff(509030) || killer.getBuffAgent().existBuff(509067))) {
                    return true;
                }
            } else {
                return true;
            }
        }
        return false;
    }
}

